//*****************************************************************************
// File Name	: lcdtest.c
// 
// Title		: example usage of some avr library functions
// Revision		: 1.0
// Notes		:	
// Target MCU	: Atmel AVR series
// Editor Tabs	: 4
// 
// Revision History:
// When			Who			Description of change
// -----------	-----------	-----------------------
// 30-Apr-2002	pstang		Created the program
//*****************************************************************************

//----- Include Files ---------------------------------------------------------
#include <ioavr.h>
#include <inavr.h>
#include <stdio.h>
#include <math.h>
#include "stdint.h"
//#include "bit_macros.h"


#include "global.h"		// include our global settings
#include "delay.h"
//#include "uart.h"		// include uart function library
//#include "rprintf.h"	// include printf function library
//#include "rprintf.c"	// include printf function library
//#include "a2d.h"		// include A/D converter function library
//#include "timer.h"		// include timer function library (timing, PWM, etc)
//#include "timer.c"
#include "lcd.h"
#include "lcd.c"

///*       -    */
#define SETBITP(ADDRESS,BIT) (ADDRESS |= (1<<BIT))
#define CLEARBITP(ADDRESS,BIT) (ADDRESS &= ~(1<<BIT))
///*        - */
#define CHECKBITP(ADDRESS,BIT) (ADDRESS & (1<<BIT))

#define DS1820 PC0

#define Low_Line SETBITP(DDRC,DS1820) 
#define Hi_Line CLEARBITP(DDRC,DS1820)


#define Read_Ram 0xbe //0xAA
#define Convert_T 0x44//0xEE//
#define Skip_Rom 0xcc
#define Read_Rom 0x0
#define Match_Rom 0x0

#define t600 370
#define t480 384//320
#define t414 331//276
#define t120 75
#define t66 53//44
#define t60 40
#define t45 29
#define t15 10
#define t5 3
#define t1 0

__no_init __regvar volatile uint8_t T@15;
__no_init volatile uint8_t str[3];

uint8_t ow_bit_io( uint8_t b )
 { uint8_t sreg;

   //sreg=SREG;
   //__disable_interrupt();
	
   Low_Line; // drive bus low
   delay_us(t15);
   //__asm("nop\n nop\n nop\n nop\n");//delay_us(t1); // Recovery-Time wuffwuff was 1
  
   if ( b ) Hi_Line; // if bit is 1 set bus high (by ext. pull-up)
	
   // wuffwuff delay was 15uS-1 see comment above
   
   delay_us(t15);
   //delay_us(t15);
      
   //if ((PINC&(1<<DS1820))==0) b=0;  // sample at end of read-timeslot
	
   delay_us(t60);//delay_us(t45);
   Hi_Line;
   delay_us(t15);
   //__enable_interrupt();
   //SREG=sreg; // sei();
	
   return b;
 }


uint8_t ow_byte_wr( uint8_t b )
 { uint8_t i = 8, j;
   do 
    { j = ow_bit_io( b & 1 );
      b >>= 1;
      if( j ) b |= 0x80;
    } 
   while( --i );
   return b;
 }



uint8_t ow_byte_rd( void )
{ uint8_t i = 8, j, sreg,b=0xff;
   do 
    { 
      // sreg=SREG;
   //__disable_interrupt();
	
   Low_Line; // drive bus low
   delay_us(t5);
   //__asm("nop\n nop\n nop\n nop\n");//delay_us(t1); // Recovery-Time wuffwuff was 1
  
   Hi_Line; 
	   
   delay_us(t5);
   j=1;
   if ((PINC&(1<<DS1820))==0) j=0;  // sample at end of read-timeslot
	
   delay_us(t45);//delay_us(t60);
   
   //__enable_interrupt();
  // SREG=sreg; // sei();
      //j = ow_bit_io( b & 1 );
      
      
      b >>= 1;
      if( j ) b |= 0x80;
    } 
   while( --i );
   return b;
  
  

	
   //return b;*/
   // read by sending 0xff (a dontcare?)
  // return ow_byte_wr( 0xFF ); 
 }


static void Rst_Prs()
{
  Low_Line;
  delay_us(t600);
  Hi_Line;
  delay_us(t120);
 
  delay_us(t600);
} 


static int Read_T()
{uint8_t T1,T2;
 uint8_t Tout;
 Rst_Prs();
 ow_byte_wr(Skip_Rom);
 ow_byte_wr(Convert_T);

do{
    
 }while(ow_byte_rd()==0);

 Rst_Prs();
 ow_byte_wr(Skip_Rom);
 ow_byte_wr(Read_Ram); 
 T1=ow_byte_rd();
 T2=ow_byte_rd();
 Rst_Prs();

 T1=(T1<<4)&240;
 T2=(T2>>4)&15;
 T2|=T1;
 
 if(T1>128) Tout=(-1)*(T2&127);
   else
     Tout=T2&127;
   
 return Tout;
}

static uint8_t conv2to10(uint8_t tv)
{ 
  static uint8_t templl=0,temphh=0, loop=2;
  static uint8_t i=0;
  //lcdGotoXY(0,1);
  templl=100;
  do{
      
      temphh=0;
      while (tv>templl)
        {
        
          tv-=templl;
          temphh++;
        
         };
        str[i]=temphh+0x30;
        //lcdDataWrite(temphh+0x30);
        i++;
        templl=10;
        loop--;
  }while(loop>0);
  //lcdDataWrite(tv+0x30);//tv+0x30;
  str[i]=tv+0x30;
  return 0;
}  

//----- Begin Code ------------------------------------------------------------
__C_task main(void)
{  
	DDRB=0;
        PORTB=0;
        PORTC=0;
        DDRC=0;

	
	//timerInit();
		// initialize LCD
	lcdInit();
	        
	// print message on LCD
	
        while(1)
	{ 	
		//
               lcdGotoXY(0,0);
               lcdPrintData("Result",6);
               T=Read_T();  
               conv2to10(T);
               lcdGotoXY(0,1);
               lcdPrintData((char*)str,3); 
               
               //lcdGotoXY(0,1);
               //lcdPrintData((char*)str,3);
	}
        
	//return 0;
}


